/* This program was made to time access 
 * to random memory
 */

#include <stdio.h>
#include <stdlib.h>

#define LARGE 100000000
#define LARGE2 1000034

static unsigned long long rdtsctime()
{
    unsigned int eax, edx;
    unsigned long long val;
    __asm__ __volatile__("cpuid": : : "ax", "bx", "cx", "dx");
    __asm__ __volatile__("rdtsc":"=a"(eax), "=d"(edx));
    val = edx;
    val = val << 32;
    val += eax;
    return val;
}

int main(void) {
  unsigned long long start,stop;
  int i,j,a;
  char *data;
  /* Calculate how fast the timing-routine is */
  /* 3 samples */
  for (i=0; i<3; i++) {
    start = rdtsctime();
    stop  = rdtsctime();
    printf("Time to start/stop the timer in cycles: %d\n", stop-start);
  }

  /* Malloc a large array */
  data = (char*)malloc(LARGE); 

  /* Traverse it to make sure its not paged out */
  for (i= 0; i<LARGE; i++) {
    a+=data[i];
  }
  j = 0;

  /* Access a singe element and time it */ 
  for (i = 0; i<3; i++) {
    j+=LARGE2;
    start = rdtsctime();
    a+=data[j];
    stop  = rdtsctime() +a;
    printf("Time to access data in cycles: %d\n", stop-start);
    start = rdtsctime();
    a+=data[j+1];
    stop  = rdtsctime()+ a;
    printf("Time to access data+1 in cycles: %d\n", stop-start);
    start = rdtsctime();
    a+=data[j+130];
    stop  = rdtsctime()+ a;
    printf("Time to access data+130 in cycles: %d\n", stop-start);
  }
  /* This statement is here to keep gcc from optimizing away a */
  printf("A is %d\n", a);

  return 0;
}
