#!/usr/bin/python
# This script creates a gnuplot file such that the data file created
# by the parsebench script can be used

import config
import sys

print '#This Gnuplot file was automatically created'
print 'set terminal postscript'
print 'set output "',
sys.stdout.write(config.experimentname)
print '.ps"'
print 'set ylabel "IPC"'
print 'set xlabel "Benchmark"'
print ''
print '#Set up some pretty xaxis names'
# Set up pretty xaxis names by benchmark
i = 1
j = 0
sys.stdout.write('set xtics rotate (')
for benchmark in config.benchmarks:
  if j == 1 :
    sys.stdout.write(',')
  j = 1
  sys.stdout.write('"')
  sys.stdout.write(benchmark[0])
  sys.stdout.write('" ')
  print i,
  i=i+1

sys.stdout.write(')\n')

print ''
print ''
# Actual plotting
sys.stdout.write('plot [*:*] [0:*] ')
# First configuration starts at column 3
column = 3
# Size of each bar
barsize = 0.8 / len(config.configurations)
# Startpoint for x plotting
x = -0.4
# Check to see if making ,\ is needed
j = 0
# Per configuration plotting
for conf in config.configurations:
  if j == 1:
    print ',\\'
  j = 1  
  sys.stdout.write('"')
  sys.stdout.write(config.experimentname)
  sys.stdout.write('.dat" using ($2')
  if x >= 0:
    sys.stdout.write('+')
  print "%-0.2f"%x,
  sys.stdout.write('):')
  print column,
  sys.stdout.write(':(')
  print barsize,
  sys.stdout.write(') title \'')
  sys.stdout.write(conf[0])
  print '\' w boxes fs pattern ',
  print column-2,
  column = column + 1
  x = x + barsize

print ''
